#coding=utf-8
class WatchesService
  def watch params
    @current_user = User.find(params[:current_user_id])
    if params[:object_type] == 'user' && params[:current_user_id] == params[:object_id]
       raise '不能关注自己！'
    end
    @watchables = find_watchables params

    if @watchables.nil?
      raise '404'
    end
    set_watcher(@watchables, @current_user, true)
  end

  def unwatch params
    @current_user = User.find(params[:current_user_id])
    @watchables = find_watchables params
    if @watchables.nil?
      raise '404'
    end
    set_watcher(@watchables, @current_user, false)
  end

  def find_watchables params
    #根据参数获取关注对象的类型（user、project）
    klass = Object.const_get(params[:object_type].camelcase) rescue nil
    #判断获取的对象类型能否响应‘watched_by’方法
    if klass && klass.respond_to?('watched_by')
      @watchables = klass.find_all_by_id(Array.wrap(params[:object_id]))
      raise Unauthorized if @watchables.any? {|w| w.respond_to?(:visible?) && !w.visible?}
    end
    @watchables.present? ? @watchables : nil
  end

  def set_watcher(watchables, user, watching)
    watchables.each do |watchable|
      watchable.set_watcher(user, watching)
      #  @user = watchable     # added by william
      if watching
        # 修改 user和project的状态
        if watchable.instance_of?(User)
          #写user_statuses表
          UserStatus.find_by_user_id(watchable.id).update_watchers_count(1)
        elsif watchable.instance_of?(Project)
          #写project_statuese表
          ProjectStatus.find_by_project_id(watchable.id).update_watchers_count(1)
        end
      else
        # 修改 user和project的状态
        if watchable.instance_of?(User)
          #写user_statuses表
          UserStatus.find_by_user_id(watchable.id).update_watchers_count(-1)
        elsif watchable.instance_of?(Project)
          #写project_statuese表 :project_status
          ProjectStatus.find_by_project_id(watchable.id).update_watchers_count(-1)
        end
      end
    end
    watchables
  end
end